Index: /palm/trunk/SOURCE/advec_s_bc.f90
===================================================================
--- /palm/trunk/SOURCE/advec_s_bc.f90	(revision 1319)
+++ /palm/trunk/SOURCE/advec_s_bc.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -37,26 +42,4 @@
 ! 1010 2012-09-20 07:59:54Z raasch
 ! cpp switch __nopointer added for pointer free version
-!
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
-!
-! 247 2009-02-27 14:01:30Z heinze
-! Output of messages replaced by message handling routine
-!
-! 216 2008-11-25 07:12:43Z raasch
-! Neumann boundary condition at k=nzb is explicitly set for better reading,
-! although this has been already done in boundary_conds
-!
-! 97 2007-06-21 08:23:15Z raasch
-! Advection of salinity included
-! Bugfix: Error in boundary condition for TKE removed
-!
-! 63 2007-03-13 03:52:49Z raasch
-! Calculation extended for gridpoint nzt
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.22  2006/02/23 09:42:08  raasch
-! anz renamed ngp
 !
 ! Revision 1.1  1997/08/29 08:53:46  raasch
@@ -77,39 +60,101 @@
 !------------------------------------------------------------------------------!
 
-    USE advection
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
+    USE advection,                                                             &
+        ONLY:  aex, bex, dex, eex
+
+    USE arrays_3d,                                                             &
+        ONLY:  d, ddzw, dzu, dzw, tend, u, v, w
+
+    USE control_parameters,                                                    &
+        ONLY:  dt_3d, bc_pt_t_val, bc_q_t_val, ibc_pt_b, ibc_pt_t, ibc_q_t,    &
+               message_string, pt_slope_offset, sloping_surface, u_gtrans,     &
+               v_gtrans
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx, ddy
+
+    USE indices,                                                               &
+        ONLY:  nx, nxl, nxr, nyn, nys, nzb, nzt
+
+    USE kinds
+
     USE pegrid
-    USE statistics
+
+    USE statistics,                                                            &
+        ONLY:  rmask, statistic_regions, sums_wsts_bc_l
+
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  sk_char
-
-    INTEGER ::  i, ix, j, k, ngp, sr, type_xz_2
-
-    REAL ::  cim, cimf, cip, cipf, d_new, fminus, fplus, f2, f4, f8,        &
-             f12, f24, f48, f1920, im, ip, m2, m3, nenner, snenn, sterm,    &
-             tendenz, t1, t2, zaehler
-    REAL ::  fmax(2), fmax_l(2)
+    CHARACTER (LEN=*) ::  sk_char !:
+
+    INTEGER(iwp) ::  i         !:
+    INTEGER(iwp) ::  ix        !:
+    INTEGER(iwp) ::  j         !:
+    INTEGER(iwp) ::  k         !:
+    INTEGER(iwp) ::  ngp       !:
+    INTEGER(iwp) ::  sr        !:
+    INTEGER(iwp) ::  type_xz_2 !:
+
+    REAL(wp) ::  cim    !:
+    REAL(wp) ::  cimf   !:
+    REAL(wp) ::  cip    !:
+    REAL(wp) ::  cipf   !:
+    REAL(wp) ::  d_new  !:
+    REAL(wp) ::  denomi !: denominator
+    REAL(wp) ::  fminus !:
+    REAL(wp) ::  fplus  !:
+    REAL(wp) ::  f2     !:
+    REAL(wp) ::  f4     !:
+    REAL(wp) ::  f8     !:
+    REAL(wp) ::  f12    !:
+    REAL(wp) ::  f24    !:
+    REAL(wp) ::  f48    !:
+    REAL(wp) ::  f1920  !:
+    REAL(wp) ::  im     !:
+    REAL(wp) ::  ip     !:
+    REAL(wp) ::  m2     !:
+    REAL(wp) ::  m3     !:
+    REAL(wp) ::  numera !: numerator
+    REAL(wp) ::  snenn  !:
+    REAL(wp) ::  sterm  !:
+    REAL(wp) ::  tendcy !:
+    REAL(wp) ::  t1     !:
+    REAL(wp) ::  t2     !:
+
+    REAL(wp) ::  fmax(2)   !:
+    REAL(wp) ::  fmax_l(2) !:
+    
 #if defined( __nopointer )
-    REAL, DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk
+    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !:
 #else
-    REAL, DIMENSION(:,:,:), POINTER ::  sk
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  sk
 #endif
 
-    REAL, DIMENSION(:,:), ALLOCATABLE ::  a0, a1, a12, a2, a22, immb, imme,  &
-                                          impb, impe, ipmb, ipme, ippb, ippe
-    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  sk_p
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  a0   !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  a1   !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  a12  !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  a2   !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  a22  !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  immb !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  imme !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  impb !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  impe !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ipmb !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ipme !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ippb !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ippe !:
+    
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  sk_p !:
 
 #if defined( __nec )
-    REAL (kind=4) ::  m1n, m1z  !Wichtig: Division
-    REAL (kind=4), DIMENSION(:,:), ALLOCATABLE :: m1, sw
+    REAL(sp) ::  m1n, m1z  !Wichtig: Division !:
+    REAL(sp), DIMENSION(:,:), ALLOCATABLE :: m1, sw !:
 #else
-    REAL ::  m1n, m1z
-    REAL, DIMENSION(:,:), ALLOCATABLE :: m1, sw
+    REAL(wp) ::  m1n, m1z 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: m1, sw
 #endif
 
@@ -148,11 +193,11 @@
 !
 !-- Send left boundary, receive right boundary
-    CALL MPI_SENDRECV( sk_p(nzb-2,nys-3,nxl+1), ngp, MPI_REAL, pleft,  0, &
-                       sk_p(nzb-2,nys-3,nxr+2), ngp, MPI_REAL, pright, 0, &
+    CALL MPI_SENDRECV( sk_p(nzb-2,nys-3,nxl+1), ngp, MPI_REAL, pleft,  0,      &
+                       sk_p(nzb-2,nys-3,nxr+2), ngp, MPI_REAL, pright, 0,      &
                        comm2d, status, ierr )
 !
 !-- Send right boundary, receive left boundary
-    CALL MPI_SENDRECV( sk_p(nzb-2,nys-3,nxr-2), ngp, MPI_REAL, pright, 1, &
-                       sk_p(nzb-2,nys-3,nxl-3), ngp, MPI_REAL, pleft,  1, &
+    CALL MPI_SENDRECV( sk_p(nzb-2,nys-3,nxr-2), ngp, MPI_REAL, pright, 1,      &
+                       sk_p(nzb-2,nys-3,nxl-3), ngp, MPI_REAL, pleft,  1,      &
                        comm2d, status, ierr )
     CALL cpu_log( log_point_s(11), 'advec_s_bc:sendrecv', 'pause' )
@@ -192,8 +237,8 @@
        DO  j = nys, nyn
           DO  k = nzb+1, nzt
-             zaehler = ABS( sk_p(k,j,i+1) - 2.0 * sk_p(k,j,i) + sk_p(k,j,i-1) )
-             nenner  = ABS( sk_p(k,j,i+1) - sk_p(k,j,i-1) )
-             fmax_l(1) = MAX( fmax_l(1) , zaehler )
-             fmax_l(2) = MAX( fmax_l(2) , nenner  )
+             numera = ABS( sk_p(k,j,i+1) - 2.0 * sk_p(k,j,i) + sk_p(k,j,i-1) )
+             denomi  = ABS( sk_p(k,j,i+1) - sk_p(k,j,i-1) )
+             fmax_l(1) = MAX( fmax_l(1) , numera )
+             fmax_l(2) = MAX( fmax_l(2) , denomi  )
           ENDDO
        ENDDO
@@ -210,12 +255,12 @@
 !
 !-- Allocate temporary arrays
-    ALLOCATE( a0(nzb+1:nzt,nxl-1:nxr+1),   a1(nzb+1:nzt,nxl-1:nxr+1),   &
-              a2(nzb+1:nzt,nxl-1:nxr+1),   a12(nzb+1:nzt,nxl-1:nxr+1),  &
-              a22(nzb+1:nzt,nxl-1:nxr+1),  immb(nzb+1:nzt,nxl-1:nxr+1), &
-              imme(nzb+1:nzt,nxl-1:nxr+1), impb(nzb+1:nzt,nxl-1:nxr+1), &
-              impe(nzb+1:nzt,nxl-1:nxr+1), ipmb(nzb+1:nzt,nxl-1:nxr+1), &
-              ipme(nzb+1:nzt,nxl-1:nxr+1), ippb(nzb+1:nzt,nxl-1:nxr+1), &
-              ippe(nzb+1:nzt,nxl-1:nxr+1), m1(nzb+1:nzt,nxl-2:nxr+2),   &
-              sw(nzb+1:nzt,nxl-1:nxr+1)                                 &
+    ALLOCATE( a0(nzb+1:nzt,nxl-1:nxr+1),   a1(nzb+1:nzt,nxl-1:nxr+1),          &
+              a2(nzb+1:nzt,nxl-1:nxr+1),   a12(nzb+1:nzt,nxl-1:nxr+1),         &
+              a22(nzb+1:nzt,nxl-1:nxr+1),  immb(nzb+1:nzt,nxl-1:nxr+1),        &
+              imme(nzb+1:nzt,nxl-1:nxr+1), impb(nzb+1:nzt,nxl-1:nxr+1),        &
+              impe(nzb+1:nzt,nxl-1:nxr+1), ipmb(nzb+1:nzt,nxl-1:nxr+1),        &
+              ipme(nzb+1:nzt,nxl-1:nxr+1), ippb(nzb+1:nzt,nxl-1:nxr+1),        &
+              ippe(nzb+1:nzt,nxl-1:nxr+1), m1(nzb+1:nzt,nxl-2:nxr+2),          &
+              sw(nzb+1:nzt,nxl-1:nxr+1)                                        &
             )
     imme = 0.0; impe = 0.0; ipme = 0.0; ippe = 0.0
@@ -236,14 +281,14 @@
           DO  k = nzb+1, nzt
              a12(k,i) = 0.5 * ( sk_p(k,j,i+1) - sk_p(k,j,i-1) )
-             a22(k,i) = 0.5 * ( sk_p(k,j,i+1) - 2.0 * sk_p(k,j,i) &
+             a22(k,i) = 0.5 * ( sk_p(k,j,i+1) - 2.0 * sk_p(k,j,i)              &
                                               + sk_p(k,j,i-1) )
-             a0(k,i) = ( 9.0 * sk_p(k,j,i+2) - 116.0 * sk_p(k,j,i+1)    &
-                         + 2134.0 * sk_p(k,j,i) - 116.0 * sk_p(k,j,i-1) &
+             a0(k,i) = ( 9.0 * sk_p(k,j,i+2) - 116.0 * sk_p(k,j,i+1)           &
+                         + 2134.0 * sk_p(k,j,i) - 116.0 * sk_p(k,j,i-1)        &
                          + 9.0 * sk_p(k,j,i-2) ) * f1920
-             a1(k,i) = ( -5.0 * sk_p(k,j,i+2) + 34.0 * sk_p(k,j,i+1)  &
-                         - 34.0 * sk_p(k,j,i-1) + 5.0 * sk_p(k,j,i-2) &
+             a1(k,i) = ( -5.0 * sk_p(k,j,i+2) + 34.0 * sk_p(k,j,i+1)           &
+                         - 34.0 * sk_p(k,j,i-1) + 5.0 * sk_p(k,j,i-2)          &
                        ) * f48
-             a2(k,i) = ( -3.0 * sk_p(k,j,i+2) + 36.0 * sk_p(k,j,i+1) &
-                         - 66.0 * sk_p(k,j,i) + 36.0 * sk_p(k,j,i-1) &
+             a2(k,i) = ( -3.0 * sk_p(k,j,i+2) + 36.0 * sk_p(k,j,i+1)           &
+                         - 66.0 * sk_p(k,j,i) + 36.0 * sk_p(k,j,i-1)           &
                          - 3.0 * sk_p(k,j,i-2) ) * f48
           ENDDO
@@ -259,9 +304,9 @@
              cipf = 1.0 - 2.0 * cip
              cimf = 1.0 - 2.0 * cim
-             ip   =   a0(k,i)   * f2  * ( 1.0 - cipf )             &
-                    + a1(k,i)   * f8  * ( 1.0 - cipf*cipf )        &
+             ip   =   a0(k,i)   * f2  * ( 1.0 - cipf )                         &
+                    + a1(k,i)   * f8  * ( 1.0 - cipf*cipf )                    &
                     + a2(k,i)   * f24 * ( 1.0 - cipf*cipf*cipf )
-             im   =   a0(k,i+1) * f2  * ( 1.0 - cimf )             &
-                    - a1(k,i+1) * f8  * ( 1.0 - cimf*cimf )        &
+             im   =   a0(k,i+1) * f2  * ( 1.0 - cimf )                         &
+                    - a1(k,i+1) * f8  * ( 1.0 - cimf*cimf )                    &
                     + a2(k,i+1) * f24 * ( 1.0 - cimf*cimf*cimf )
              ip   = MAX( ip, 0.0 )
@@ -274,9 +319,9 @@
              cipf = 1.0 - 2.0 * cip
              cimf = 1.0 - 2.0 * cim
-             ip   =   a0(k,i-1) * f2  * ( 1.0 - cipf )             &
-                    + a1(k,i-1) * f8  * ( 1.0 - cipf*cipf )        &
+             ip   =   a0(k,i-1) * f2  * ( 1.0 - cipf )                         &
+                    + a1(k,i-1) * f8  * ( 1.0 - cipf*cipf )                    &
                     + a2(k,i-1) * f24 * ( 1.0 - cipf*cipf*cipf )
-             im   =   a0(k,i)   * f2  * ( 1.0 - cimf )             &
-                    - a1(k,i)   * f8  * ( 1.0 - cimf*cimf )        &
+             im   =   a0(k,i)   * f2  * ( 1.0 - cimf )                         &
+                    - a1(k,i)   * f8  * ( 1.0 - cimf*cimf )                    &
                     + a2(k,i)   * f24 * ( 1.0 - cimf*cimf*cimf )
              ip   = MAX( ip, 0.0 )
@@ -309,9 +354,9 @@
        DO  i = nxl-1, nxr+1
           DO  k = nzb+1, nzt
-             m2 = 2.0 * ABS( a1(k,i) - a12(k,i) ) / &
+             m2 = 2.0 * ABS( a1(k,i) - a12(k,i) ) /                            &
                   MAX( ABS( a1(k,i) + a12(k,i) ), 1E-35 )
              IF ( ABS( a1(k,i) + a12(k,i) ) < fmax(2) )  m2 = 0.0
 
-             m3 = 2.0 * ABS( a2(k,i) - a22(k,i) ) / &
+             m3 = 2.0 * ABS( a2(k,i) - a22(k,i) ) /                            &
                   MAX( ABS( a2(k,i) + a22(k,i) ), 1E-35 )
              IF ( ABS( a2(k,i) + a22(k,i) ) < fmax(1) )  m3 = 0.0
@@ -322,8 +367,8 @@
 
 !--          *VOCL STMT,IF(10)
-             IF ( m1(k,i-1) == 1.0 .OR. m1(k,i) == 1.0 .OR. m1(k,i+1) == 1.0 &
-                  .OR.  m2 > t2  .OR.  m3 > T2  .OR.                         &
-                  ( m1(k,i) > t1  .AND.  m1(k,i-1) /= -1.0  .AND.            &
-                    m1(k,i) /= -1.0  .AND.  m1(k,i+1) /= -1.0 )              &
+             IF ( m1(k,i-1) == 1.0 .OR. m1(k,i) == 1.0 .OR. m1(k,i+1) == 1.0   &
+                  .OR.  m2 > t2  .OR.  m3 > t2  .OR.                           &
+                  ( m1(k,i) > t1  .AND.  m1(k,i-1) /= -1.0  .AND.              &
+                    m1(k,i) /= -1.0  .AND.  m1(k,i+1) /= -1.0 )                &
                 )  sw(k,i) = 1.0
           ENDDO
@@ -425,17 +470,17 @@
        DO  i = nxl, nxr
           DO  k = nzb+1, nzt
-             fplus  = ( 1.0 - sw(k,i)   ) * ippb(k,i) + sw(k,i)   * ippe(k,i) &
+             fplus  = ( 1.0 - sw(k,i)   ) * ippb(k,i) + sw(k,i)   * ippe(k,i)  &
                     - ( 1.0 - sw(k,i+1) ) * impb(k,i) - sw(k,i+1) * impe(k,i)
-             fminus = ( 1.0 - sw(k,i-1) ) * ipmb(k,i) + sw(k,i-1) * ipme(k,i) &
+             fminus = ( 1.0 - sw(k,i-1) ) * ipmb(k,i) + sw(k,i-1) * ipme(k,i)  &
                     - ( 1.0 - sw(k,i)   ) * immb(k,i) - sw(k,i)   * imme(k,i)
-             tendenz = fplus - fminus
+             tendcy = fplus - fminus
 !
 !--           Removed in order to optimize speed
 !             ffmax   = MAX( ABS( fplus ), ABS( fminus ), 1E-35 )
-!             IF ( ( ABS( tendenz ) / ffmax ) < 1E-7 )  tendenz = 0.0
+!             IF ( ( ABS( tendcy ) / ffmax ) < 1E-7 )  tendcy = 0.0
 !
 !--          Density correction because of possible remaining divergences
              d_new = d(k,j,i) - ( u(k,j,i+1) - u(k,j,i) ) * dt_3d * ddx
-             sk_p(k,j,i) = ( ( 1.0 + d(k,j,i) ) * sk_p(k,j,i) - tendenz ) / &
+             sk_p(k,j,i) = ( ( 1.0 + d(k,j,i) ) * sk_p(k,j,i) - tendcy ) /    &
                            ( 1.0 + d_new )
              d(k,j,i)  = d_new
@@ -447,5 +492,5 @@
 !
 !-- Deallocate temporary arrays
-    DEALLOCATE( a0, a1, a2, a12, a22, immb, imme, impb, impe, ipmb, ipme, &
+    DEALLOCATE( a0, a1, a2, a12, a22, immb, imme, impb, impe, ipmb, ipme,      &
                 ippb, ippe, m1, sw )
 
@@ -455,5 +500,5 @@
 #if defined( __parallel )
     ngp = ( nzt - nzb + 6 ) * ( nyn - nys + 7 )
-    CALL MPI_TYPE_VECTOR( nxr-nxl+7, 3*(nzt-nzb+6), ngp, MPI_REAL, &
+    CALL MPI_TYPE_VECTOR( nxr-nxl+7, 3*(nzt-nzb+6), ngp, MPI_REAL,             &
                           type_xz_2, ierr )
     CALL MPI_TYPE_COMMIT( type_xz_2, ierr )
@@ -461,11 +506,11 @@
 !-- Send front boundary, receive rear boundary
     CALL cpu_log( log_point_s(11), 'advec_s_bc:sendrecv', 'continue' )
-    CALL MPI_SENDRECV( sk_p(nzb-2,nys,nxl-3),   1, type_xz_2, psouth, 0, &
-                       sk_p(nzb-2,nyn+1,nxl-3), 1, type_xz_2, pnorth, 0, &
+    CALL MPI_SENDRECV( sk_p(nzb-2,nys,nxl-3),   1, type_xz_2, psouth, 0,       &
+                       sk_p(nzb-2,nyn+1,nxl-3), 1, type_xz_2, pnorth, 0,       &
                        comm2d, status, ierr )
 !
 !-- Send rear boundary, receive front boundary
-    CALL MPI_SENDRECV( sk_p(nzb-2,nyn-2,nxl-3), 1, type_xz_2, pnorth, 1, &
-                       sk_p(nzb-2,nys-3,nxl-3), 1, type_xz_2, psouth, 1, &
+    CALL MPI_SENDRECV( sk_p(nzb-2,nyn-2,nxl-3), 1, type_xz_2, pnorth, 1,       &
+                       sk_p(nzb-2,nys-3,nxl-3), 1, type_xz_2, psouth, 1,       &
                        comm2d, status, ierr )
     CALL MPI_TYPE_FREE( type_xz_2, ierr )
@@ -490,8 +535,8 @@
        DO  j = nys, nyn
           DO  k = nzb+1, nzt
-             zaehler = ABS( sk_p(k,j+1,i) - 2.0 * sk_p(k,j,i) + sk_p(k,j-1,i) )
-             nenner  = ABS( sk_p(k,j+1,i) - sk_p(k,j-1,i) )
-             fmax_l(1) = MAX( fmax_l(1) , zaehler )
-             fmax_l(2) = MAX( fmax_l(2) , nenner  )
+             numera = ABS( sk_p(k,j+1,i) - 2.0 * sk_p(k,j,i) + sk_p(k,j-1,i) )
+             denomi  = ABS( sk_p(k,j+1,i) - sk_p(k,j-1,i) )
+             fmax_l(1) = MAX( fmax_l(1) , numera )
+             fmax_l(2) = MAX( fmax_l(2) , denomi  )
           ENDDO
        ENDDO
@@ -508,12 +553,12 @@
 !
 !-- Allocate temporary arrays
-    ALLOCATE( a0(nzb+1:nzt,nys-1:nyn+1),   a1(nzb+1:nzt,nys-1:nyn+1),   &
-              a2(nzb+1:nzt,nys-1:nyn+1),   a12(nzb+1:nzt,nys-1:nyn+1),  &
-              a22(nzb+1:nzt,nys-1:nyn+1),  immb(nzb+1:nzt,nys-1:nyn+1), &
-              imme(nzb+1:nzt,nys-1:nyn+1), impb(nzb+1:nzt,nys-1:nyn+1), &
-              impe(nzb+1:nzt,nys-1:nyn+1), ipmb(nzb+1:nzt,nys-1:nyn+1), &
-              ipme(nzb+1:nzt,nys-1:nyn+1), ippb(nzb+1:nzt,nys-1:nyn+1), &
-              ippe(nzb+1:nzt,nys-1:nyn+1), m1(nzb+1:nzt,nys-2:nyn+2),   &
-              sw(nzb+1:nzt,nys-1:nyn+1)                                 &
+    ALLOCATE( a0(nzb+1:nzt,nys-1:nyn+1),   a1(nzb+1:nzt,nys-1:nyn+1),          &
+              a2(nzb+1:nzt,nys-1:nyn+1),   a12(nzb+1:nzt,nys-1:nyn+1),         &
+              a22(nzb+1:nzt,nys-1:nyn+1),  immb(nzb+1:nzt,nys-1:nyn+1),        &
+              imme(nzb+1:nzt,nys-1:nyn+1), impb(nzb+1:nzt,nys-1:nyn+1),        &
+              impe(nzb+1:nzt,nys-1:nyn+1), ipmb(nzb+1:nzt,nys-1:nyn+1),        &
+              ipme(nzb+1:nzt,nys-1:nyn+1), ippb(nzb+1:nzt,nys-1:nyn+1),        &
+              ippe(nzb+1:nzt,nys-1:nyn+1), m1(nzb+1:nzt,nys-2:nyn+2),          &
+              sw(nzb+1:nzt,nys-1:nyn+1)                                        &
             )
     imme = 0.0; impe = 0.0; ipme = 0.0; ippe = 0.0
@@ -528,14 +573,14 @@
           DO  k = nzb+1, nzt
              a12(k,j) = 0.5 * ( sk_p(k,j+1,i) - sk_p(k,j-1,i) )
-             a22(k,j) = 0.5 * ( sk_p(k,j+1,i) - 2.0 * sk_p(k,j,i) &
+             a22(k,j) = 0.5 * ( sk_p(k,j+1,i) - 2.0 * sk_p(k,j,i)              &
                                               + sk_p(k,j-1,i) )
-             a0(k,j) = ( 9.0 * sk_p(k,j+2,i) - 116.0 * sk_p(k,j+1,i)    &
-                         + 2134.0 * sk_p(k,j,i) - 116.0 * sk_p(k,j-1,i) &
+             a0(k,j) = ( 9.0 * sk_p(k,j+2,i) - 116.0 * sk_p(k,j+1,i)           &
+                         + 2134.0 * sk_p(k,j,i) - 116.0 * sk_p(k,j-1,i)        &
                          + 9.0 * sk_p(k,j-2,i) ) * f1920
-             a1(k,j) = ( -5.0 * sk_p(k,j+2,i) + 34.0 * sk_p(k,j+1,i)  &
-                         - 34.0 * sk_p(k,j-1,i) + 5.0 * sk_p(k,j-2,i) &
+             a1(k,j) = ( -5.0 * sk_p(k,j+2,i) + 34.0 * sk_p(k,j+1,i)           &
+                         - 34.0 * sk_p(k,j-1,i) + 5.0 * sk_p(k,j-2,i)          &
                        ) * f48
-             a2(k,j) = ( -3.0 * sk_p(k,j+2,i) + 36.0 * sk_p(k,j+1,i) &
-                         - 66.0 * sk_p(k,j,i) + 36.0 * sk_p(k,j-1,i) &
+             a2(k,j) = ( -3.0 * sk_p(k,j+2,i) + 36.0 * sk_p(k,j+1,i)           &
+                         - 66.0 * sk_p(k,j,i) + 36.0 * sk_p(k,j-1,i)           &
                          - 3.0 * sk_p(k,j-2,i) ) * f48
           ENDDO
@@ -551,9 +596,9 @@
              cipf = 1.0 - 2.0 * cip
              cimf = 1.0 - 2.0 * cim
-             ip   =   a0(k,j)   * f2  * ( 1.0 - cipf )             &
-                    + a1(k,j)   * f8  * ( 1.0 - cipf*cipf )        &
+             ip   =   a0(k,j)   * f2  * ( 1.0 - cipf )                         &
+                    + a1(k,j)   * f8  * ( 1.0 - cipf*cipf )                    &
                     + a2(k,j)   * f24 * ( 1.0 - cipf*cipf*cipf )
-             im   =   a0(k,j+1) * f2  * ( 1.0 - cimf )             &
-                    - a1(k,j+1) * f8  * ( 1.0 - cimf*cimf )        &
+             im   =   a0(k,j+1) * f2  * ( 1.0 - cimf )                         &
+                    - a1(k,j+1) * f8  * ( 1.0 - cimf*cimf )                    &
                     + a2(k,j+1) * f24 * ( 1.0 - cimf*cimf*cimf )
              ip   = MAX( ip, 0.0 )
@@ -566,9 +611,9 @@
              cipf = 1.0 - 2.0 * cip
              cimf = 1.0 - 2.0 * cim
-             ip   =   a0(k,j-1) * f2  * ( 1.0 - cipf )             &
-                    + a1(k,j-1) * f8  * ( 1.0 - cipf*cipf )        &
+             ip   =   a0(k,j-1) * f2  * ( 1.0 - cipf )                         &
+                    + a1(k,j-1) * f8  * ( 1.0 - cipf*cipf )                    &
                     + a2(k,j-1) * f24 * ( 1.0 - cipf*cipf*cipf )
-             im   =   a0(k,j)   * f2  * ( 1.0 - cimf )             &
-                    - a1(k,j)   * f8  * ( 1.0 - cimf*cimf )        &
+             im   =   a0(k,j)   * f2  * ( 1.0 - cimf )                         &
+                    - a1(k,j)   * f8  * ( 1.0 - cimf*cimf )                    &
                     + a2(k,j)   * f24 * ( 1.0 - cimf*cimf*cimf )
              ip   = MAX( ip, 0.0 )
@@ -601,9 +646,9 @@
        DO  j = nys-1, nyn+1
           DO  k = nzb+1, nzt
-             m2 = 2.0 * ABS( a1(k,j) - a12(k,j) ) / &
+             m2 = 2.0 * ABS( a1(k,j) - a12(k,j) ) /                            &
                   MAX( ABS( a1(k,j) + a12(k,j) ), 1E-35 )
              IF ( ABS( a1(k,j) + a12(k,j) ) < fmax(2) )  m2 = 0.0
 
-             m3 = 2.0 * ABS( a2(k,j) - a22(k,j) ) / &
+             m3 = 2.0 * ABS( a2(k,j) - a22(k,j) ) /                            &
                   MAX( ABS( a2(k,j) + a22(k,j) ), 1E-35 )
              IF ( ABS( a2(k,j) + a22(k,j) ) < fmax(1) )  m3 = 0.0
@@ -614,8 +659,8 @@
 
 !--          *VOCL STMT,IF(10)
-             IF ( m1(k,j-1) == 1.0 .OR. m1(k,j) == 1.0 .OR. m1(k,j+1) == 1.0 &
-                  .OR.  m2 > t2  .OR.  m3 > T2  .OR.                         &
-                  ( m1(k,j) > t1  .AND.  m1(k,j-1) /= -1.0  .AND.            &
-                    m1(k,j) /= -1.0  .AND.  m1(k,j+1) /= -1.0 )              &
+             IF ( m1(k,j-1) == 1.0 .OR. m1(k,j) == 1.0 .OR. m1(k,j+1) == 1.0   &
+                  .OR.  m2 > t2  .OR.  m3 > t2  .OR.                           &
+                  ( m1(k,j) > t1  .AND.  m1(k,j-1) /= -1.0  .AND.              &
+                    m1(k,j) /= -1.0  .AND.  m1(k,j+1) /= -1.0 )                &
                 )  sw(k,j) = 1.0
           ENDDO
@@ -717,17 +762,17 @@
        DO  j = nys, nyn
           DO  k = nzb+1, nzt
-             fplus  = ( 1.0 - sw(k,j)   ) * ippb(k,j) + sw(k,j)   * ippe(k,j) &
+             fplus  = ( 1.0 - sw(k,j)   ) * ippb(k,j) + sw(k,j)   * ippe(k,j)  &
                     - ( 1.0 - sw(k,j+1) ) * impb(k,j) - sw(k,j+1) * impe(k,j)
-             fminus = ( 1.0 - sw(k,j-1) ) * ipmb(k,j) + sw(k,j-1) * ipme(k,j) &
+             fminus = ( 1.0 - sw(k,j-1) ) * ipmb(k,j) + sw(k,j-1) * ipme(k,j)  &
                     - ( 1.0 - sw(k,j)   ) * immb(k,j) - sw(k,j)   * imme(k,j)
-             tendenz = fplus - fminus
+             tendcy = fplus - fminus
 !
 !--           Removed in order to optimise speed
 !             ffmax   = MAX( ABS( fplus ), ABS( fminus ), 1E-35 )
-!             IF ( ( ABS( tendenz ) / ffmax ) < 1E-7 )  tendenz = 0.0
+!             IF ( ( ABS( tendcy ) / ffmax ) < 1E-7 )  tendcy = 0.0
 !
 !--          Density correction because of possible remaining divergences
              d_new = d(k,j,i) - ( v(k,j+1,i) - v(k,j,i) ) * dt_3d * ddy
-             sk_p(k,j,i) = ( ( 1.0 + d(k,j,i) ) * sk_p(k,j,i) - tendenz ) / &
+             sk_p(k,j,i) = ( ( 1.0 + d(k,j,i) ) * sk_p(k,j,i) - tendcy ) /    &
                            ( 1.0 + d_new )
              d(k,j,i)  = d_new
@@ -741,5 +786,5 @@
 !
 !-- Deallocate temporary arrays
-    DEALLOCATE( a0, a1, a2, a12, a22, immb, imme, impb, impe, ipmb, ipme, &
+    DEALLOCATE( a0, a1, a2, a12, a22, immb, imme, impb, impe, ipmb, ipme,      &
                 ippb, ippe, m1, sw )
 
@@ -879,5 +924,5 @@
     ELSE
 
-       WRITE( message_string, * ) 'no vertical boundary condi', &
+       WRITE( message_string, * ) 'no vertical boundary condi',                &
                                 'tion for variable "', sk_char, '"'
        CALL message( 'advec_s_bc', 'PA0158', 1, 2, 0, 6, 0 )
@@ -891,8 +936,8 @@
        DO  j = nys, nyn
           DO  k = nzb, nzt+1
-             zaehler = ABS( sk_p(k+1,j,i) - 2.0 * sk_p(k,j,i) + sk_p(k-1,j,i) )
-             nenner  = ABS( sk_p(k+1,j,i+1) - sk_p(k-1,j,i) )
-             fmax_l(1) = MAX( fmax_l(1) , zaehler )
-             fmax_l(2) = MAX( fmax_l(2) , nenner  )
+             numera = ABS( sk_p(k+1,j,i) - 2.0 * sk_p(k,j,i) + sk_p(k-1,j,i) )
+             denomi  = ABS( sk_p(k+1,j,i+1) - sk_p(k-1,j,i) )
+             fmax_l(1) = MAX( fmax_l(1) , numera )
+             fmax_l(2) = MAX( fmax_l(2) , denomi  )
           ENDDO
        ENDDO
@@ -909,12 +954,12 @@
 !
 !-- Allocate temporary arrays
-    ALLOCATE( a0(nzb:nzt+1,nys:nyn),   a1(nzb:nzt+1,nys:nyn),   &
-              a2(nzb:nzt+1,nys:nyn),   a12(nzb:nzt+1,nys:nyn),  &
-              a22(nzb:nzt+1,nys:nyn),  immb(nzb+1:nzt,nys:nyn), &
-              imme(nzb+1:nzt,nys:nyn), impb(nzb+1:nzt,nys:nyn), &
-              impe(nzb+1:nzt,nys:nyn), ipmb(nzb+1:nzt,nys:nyn), &
-              ipme(nzb+1:nzt,nys:nyn), ippb(nzb+1:nzt,nys:nyn), &
-              ippe(nzb+1:nzt,nys:nyn), m1(nzb-1:nzt+2,nys:nyn), &
-              sw(nzb:nzt+1,nys:nyn)                             &
+    ALLOCATE( a0(nzb:nzt+1,nys:nyn),   a1(nzb:nzt+1,nys:nyn),                  &
+              a2(nzb:nzt+1,nys:nyn),   a12(nzb:nzt+1,nys:nyn),                 &
+              a22(nzb:nzt+1,nys:nyn),  immb(nzb+1:nzt,nys:nyn),                &
+              imme(nzb+1:nzt,nys:nyn), impb(nzb+1:nzt,nys:nyn),                &
+              impe(nzb+1:nzt,nys:nyn), ipmb(nzb+1:nzt,nys:nyn),                &
+              ipme(nzb+1:nzt,nys:nyn), ippb(nzb+1:nzt,nys:nyn),                &
+              ippe(nzb+1:nzt,nys:nyn), m1(nzb-1:nzt+2,nys:nyn),                &
+              sw(nzb:nzt+1,nys:nyn)                                            &
             )
     imme = 0.0; impe = 0.0; ipme = 0.0; ippe = 0.0
@@ -929,14 +974,14 @@
           DO  k = nzb, nzt+1
              a12(k,j) = 0.5 * ( sk_p(k+1,j,i) - sk_p(k-1,j,i) )
-             a22(k,j) = 0.5 * ( sk_p(k+1,j,i) - 2.0 * sk_p(k,j,i) &
+             a22(k,j) = 0.5 * ( sk_p(k+1,j,i) - 2.0 * sk_p(k,j,i)              &
                                               + sk_p(k-1,j,i) )
-             a0(k,j) = ( 9.0 * sk_p(k+2,j,i) - 116.0 * sk_p(k+1,j,i)    &
-                         + 2134.0 * sk_p(k,j,i) - 116.0 * sk_p(k-1,j,i) &
+             a0(k,j) = ( 9.0 * sk_p(k+2,j,i) - 116.0 * sk_p(k+1,j,i)           &
+                         + 2134.0 * sk_p(k,j,i) - 116.0 * sk_p(k-1,j,i)        &
                          + 9.0 * sk_p(k-2,j,i) ) * f1920
-             a1(k,j) = ( -5.0 * sk_p(k+2,j,i) + 34.0 * sk_p(k+1,j,i)  &
-                         - 34.0 * sk_p(k-1,j,i) + 5.0 * sk_p(k-2,j,i) &
+             a1(k,j) = ( -5.0 * sk_p(k+2,j,i) + 34.0 * sk_p(k+1,j,i)           &
+                         - 34.0 * sk_p(k-1,j,i) + 5.0 * sk_p(k-2,j,i)          &
                        ) * f48
-             a2(k,j) = ( -3.0 * sk_p(k+2,j,i) + 36.0 * sk_p(k+1,j,i) &
-                         - 66.0 * sk_p(k,j,i) + 36.0 * sk_p(k-1,j,i) &
+             a2(k,j) = ( -3.0 * sk_p(k+2,j,i) + 36.0 * sk_p(k+1,j,i)           &
+                         - 66.0 * sk_p(k,j,i) + 36.0 * sk_p(k-1,j,i)           &
                          - 3.0 * sk_p(k-2,j,i) ) * f48
           ENDDO
@@ -952,9 +997,9 @@
              cipf = 1.0 - 2.0 * cip
              cimf = 1.0 - 2.0 * cim
-             ip   =   a0(k,j)   * f2  * ( 1.0 - cipf )             &
-                    + a1(k,j)   * f8  * ( 1.0 - cipf*cipf )        &
+             ip   =   a0(k,j)   * f2  * ( 1.0 - cipf )                         &
+                    + a1(k,j)   * f8  * ( 1.0 - cipf*cipf )                    &
                     + a2(k,j)   * f24 * ( 1.0 - cipf*cipf*cipf )
-             im   =   a0(k+1,j) * f2  * ( 1.0 - cimf )             &
-                    - a1(k+1,j) * f8  * ( 1.0 - cimf*cimf )        &
+             im   =   a0(k+1,j) * f2  * ( 1.0 - cimf )                         &
+                    - a1(k+1,j) * f8  * ( 1.0 - cimf*cimf )                    &
                     + a2(k+1,j) * f24 * ( 1.0 - cimf*cimf*cimf )
              ip   = MAX( ip, 0.0 )
@@ -967,9 +1012,9 @@
              cipf = 1.0 - 2.0 * cip
              cimf = 1.0 - 2.0 * cim
-             ip   =   a0(k-1,j) * f2  * ( 1.0 - cipf )             &
-                    + a1(k-1,j) * f8  * ( 1.0 - cipf*cipf )        &
+             ip   =   a0(k-1,j) * f2  * ( 1.0 - cipf )                         &
+                    + a1(k-1,j) * f8  * ( 1.0 - cipf*cipf )                    &
                     + a2(k-1,j) * f24 * ( 1.0 - cipf*cipf*cipf )
-             im   =   a0(k,j)   * f2  * ( 1.0 - cimf )             &
-                    - a1(k,j)   * f8  * ( 1.0 - cimf*cimf )        &
+             im   =   a0(k,j)   * f2  * ( 1.0 - cimf )                         &
+                    - a1(k,j)   * f8  * ( 1.0 - cimf*cimf )                    &
                     + a2(k,j)   * f24 * ( 1.0 - cimf*cimf*cimf )
              ip   = MAX( ip, 0.0 )
@@ -1002,9 +1047,9 @@
        DO  j = nys, nyn
           DO  k = nzb, nzt+1
-             m2 = 2.0 * ABS( a1(k,j) - a12(k,j) ) / &
+             m2 = 2.0 * ABS( a1(k,j) - a12(k,j) ) /                            &
                   MAX( ABS( a1(k,j) + a12(k,j) ), 1E-35 )
              IF ( ABS( a1(k,j) + a12(k,j) ) < fmax(2) )  m2 = 0.0
 
-             m3 = 2.0 * ABS( a2(k,j) - a22(k,j) ) / &
+             m3 = 2.0 * ABS( a2(k,j) - a22(k,j) ) /                            &
                   MAX( ABS( a2(k,j) + a22(k,j) ), 1E-35 )
              IF ( ABS( a2(k,j) + a22(k,j) ) < fmax(1) )  m3 = 0.0
@@ -1015,8 +1060,8 @@
 
 !--          *VOCL STMT,IF(10)
-             IF ( m1(k-1,j) == 1.0 .OR. m1(k,j) == 1.0 .OR. m1(k+1,j) == 1.0 &
-                  .OR.  m2 > t2  .OR.  m3 > T2  .OR.                         &
-                  ( m1(k,j) > t1  .AND.  m1(k-1,j) /= -1.0  .AND.            &
-                    m1(k,j) /= -1.0  .AND.  m1(k+1,j) /= -1.0 )              &
+             IF ( m1(k-1,j) == 1.0 .OR. m1(k,j) == 1.0 .OR. m1(k+1,j) == 1.0   &
+                  .OR.  m2 > t2  .OR.  m3 > t2  .OR.                           &
+                  ( m1(k,j) > t1  .AND.  m1(k-1,j) /= -1.0  .AND.              &
+                    m1(k,j) /= -1.0  .AND.  m1(k+1,j) /= -1.0 )                &
                 )  sw(k,j) = 1.0
           ENDDO
